// Controller: Handles user interactions
const Controller = {

    async createUser(name, email, password){
        const userCreateResponse = await Model.createUser(name, email, password);
        if(userCreateResponse.status=="success"){
            const user = userCreateResponse.data;
            View.renderUser(user);
        }
    },

    async showProducts() {
        const productsResponse = await Model.fetchProducts();
        if(productsResponse.status=="success"){
            const products = productsResponse.data;
            View.renderProducts(products);
        }
        Controller.addProductClickHandlers();
    },

    async showProduct(productId) {
        const productResponse = await Model.fetchProduct(productId);
        if(productResponse.status=="success"){
            const product = productResponse.data;
            View.renderProduct(product);
        }
        document.getElementById('back-button').addEventListener('click', () => {
            Controller.showProducts();
        });
    },

    showUserRegister(){
        View.renderUserRegister();
        document.getElementById('create-user-button').addEventListener('click', () => {
            const name = document.getElementById('user-name').value;
            const email = document.getElementById('user-email').value;
            const password = document.getElementById('user-password').value;
            Controller.createUser(name, email, password);
        });
    },

    addEventListeners() {
        document.getElementById('products-tab').addEventListener('click', (event) => {
        event.preventDefault();
        Controller.showProducts();
        });

        document.getElementById('user-tab').addEventListener('click', (event) => {
        event.preventDefault();
        Controller.showUserRegister();
        });

        document.querySelectorAll('.product-link').forEach((link) => {
            link.addEventListener('click', (event) => {
                event.preventDefault();
                const productId = event.target.getAttribute('data-id');
                Controller.showProduct(productId);
            });
            });
    },

    addProductClickHandlers() {
        document.querySelectorAll('.product-link').forEach((link) => {
        link.addEventListener('click', (event) => {
            event.preventDefault();
            const productId = event.target.getAttribute('data-id');
            Controller.showProduct(productId);
        });
        });
    },

    init() {
        this.addEventListeners();
        this.showProducts(); // Default view
    },
};
// Initialize the application
Controller.init();